<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.12.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>kmCpu: X:/kmCpu.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">kmCpu
   </div>
   <div id="projectbrief">kmCpu library for AVR</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.12.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search',true);
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('km_cpu_8h_source.html',''); initResizable(true); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">X:/kmCpu.h</div></div>
</div><!--header-->
<div class="contents">
<a href="km_cpu_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">// This is an independent project of an individual developer. Dear PVS-Studio, please check it.</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment">// PVS-Studio Static Code Analyzer for C, C++, C#, and Java: http://www.viva64.com</span></div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span><span class="preprocessor">#ifndef KMCPU_H_</span></div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span><span class="preprocessor">#define KMCPU_H_</span></div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span><span class="preprocessor">#ifdef __cplusplus</span></div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span><span class="preprocessor">#endif </span><span class="comment">/* __cplusplus */</span><span class="preprocessor"></span></div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span> </div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span><span class="preprocessor">#include &lt;avr/interrupt.h&gt;</span></div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span><span class="preprocessor">#include &lt;avr/wdt.h&gt;</span></div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span> </div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span><span class="preprocessor">#include &quot;../kmCommon/kmCommon.h&quot;</span></div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span> </div>
<div class="foldopen" id="foldopen00045" data-start="{" data-end="}">
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno"><a class="line" href="km_cpu_8h.html#a0091ca9e864da5359580d4a9e7b828d9">   45</a></span><span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code hl_function" href="km_cpu_8h.html#a0091ca9e864da5359580d4a9e7b828d9">kmCpuInterruptsEnable</a>(<span class="keywordtype">void</span>) {</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>    sei();</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>}</div>
</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span> </div>
<div class="foldopen" id="foldopen00052" data-start="{" data-end="}">
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno"><a class="line" href="km_cpu_8h.html#a89ffdd67aa53e2885528d1b820513386">   52</a></span><span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code hl_function" href="km_cpu_8h.html#a89ffdd67aa53e2885528d1b820513386">kmCpuInterruptsDisable</a>(<span class="keywordtype">void</span>) {</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>    cli();</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>}</div>
</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span> </div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span><span class="keyword">inline</span> <span class="keyword">static</span> <span class="keywordtype">void</span> kmCpuWatchdogEnable(uint8_t timeout) {</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>    wdt_enable(timeout);</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>}</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span> </div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span><span class="keyword">inline</span> <span class="keyword">static</span> <span class="keywordtype">void</span> kmCpuWatchdogDisable(<span class="keywordtype">void</span>) {</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>    wdt_disable();</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>}</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span> </div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span><span class="keyword">inline</span> <span class="keyword">static</span> <span class="keywordtype">void</span> kmCpuWatchdogReset() {</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>    wdt_reset();</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>}</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span> </div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span><span class="keywordtype">void</span> <a class="code hl_function" href="km_cpu_8h.html#a2cab7faaa3a7f692118e494d9bdca404">kmCpuHalt</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span> </div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span><span class="keywordtype">void</span> <a class="code hl_function" href="km_cpu_8h.html#accc2b1261d0ba57b5dbf5476482f9534">kmCpuSoftReset</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span> </div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span><span class="keywordtype">void</span> <a class="code hl_function" href="km_cpu_8h.html#ae403db6f1fe7e2bc5f6e0319c340fbf4">kmCpuDisableWatchdogAndInterruptsOnStartup</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span> </div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span><span class="preprocessor">#ifdef __cplusplus</span></div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>}</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span><span class="preprocessor">#endif </span><span class="comment">/* __cplusplus */</span><span class="preprocessor"></span></div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span><span class="preprocessor">#endif </span><span class="comment">/* KMCPU_H_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="akm_cpu_8h_html_a0091ca9e864da5359580d4a9e7b828d9"><div class="ttname"><a href="km_cpu_8h.html#a0091ca9e864da5359580d4a9e7b828d9">kmCpuInterruptsEnable</a></div><div class="ttdeci">void kmCpuInterruptsEnable(void)</div><div class="ttdef"><b>Definition</b> kmCpu.h:45</div></div>
<div class="ttc" id="akm_cpu_8h_html_a2cab7faaa3a7f692118e494d9bdca404"><div class="ttname"><a href="km_cpu_8h.html#a2cab7faaa3a7f692118e494d9bdca404">kmCpuHalt</a></div><div class="ttdeci">void kmCpuHalt(void)</div><div class="ttdef"><b>Definition</b> kmCpu.c:50</div></div>
<div class="ttc" id="akm_cpu_8h_html_a89ffdd67aa53e2885528d1b820513386"><div class="ttname"><a href="km_cpu_8h.html#a89ffdd67aa53e2885528d1b820513386">kmCpuInterruptsDisable</a></div><div class="ttdeci">void kmCpuInterruptsDisable(void)</div><div class="ttdef"><b>Definition</b> kmCpu.h:52</div></div>
<div class="ttc" id="akm_cpu_8h_html_accc2b1261d0ba57b5dbf5476482f9534"><div class="ttname"><a href="km_cpu_8h.html#accc2b1261d0ba57b5dbf5476482f9534">kmCpuSoftReset</a></div><div class="ttdeci">void kmCpuSoftReset(void)</div><div class="ttdef"><b>Definition</b> kmCpu.c:34</div></div>
<div class="ttc" id="akm_cpu_8h_html_ae403db6f1fe7e2bc5f6e0319c340fbf4"><div class="ttname"><a href="km_cpu_8h.html#ae403db6f1fe7e2bc5f6e0319c340fbf4">kmCpuDisableWatchdogAndInterruptsOnStartup</a></div><div class="ttdeci">void kmCpuDisableWatchdogAndInterruptsOnStartup(void)</div><div class="ttdef"><b>Definition</b> kmCpu.c:40</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="km_cpu_8h.html">kmCpu.h</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.12.0 </li>
  </ul>
</div>
</body>
</html>
